-- y'all will guess me anyway but who cares,
-- scissors is winning rock paper scissors royale!
-- (i hope)
getmetatable"".__index = function(str, key)
  if type(key) == "number" then
    return (key >= 1 and key <= #str) and str:sub(key, key) or nil
  end
  return string[key]
end
local readline = io.lines()
while 1 do
  local grid = {}
  repeat
    local line = readline()
    if not line then break end -- being nice or something
    grid[#grid+1] = line
  until line == ""
  local x = assert(tonumber(readline()))
  local y = assert(tonumber(readline()))
  local dirs = {
    L = {-1, 0},
    R = {1, 0},
    U = {0, -1},
    D = {0, 1},
  }
  local function get_tile(tx, ty)
    return (grid[ty] or {})[tx] or "#"
  end
  local function murder(K, V)
    local function dist(mx, my)
      local res = 0
      local level = {{mx, my}}
      local visited = {[my] = {[mx] = true}}
      repeat
        local next_level = {}
        for _, pos in ipairs(level) do
          local px, py = table.unpack(pos)
          for dn, dp in pairs(dirs) do
            local dx, dy = table.unpack(dp)
            local nx, ny = px + dx, py + dy
            if ({[K..V]=1,[V..K]=1})[get_tile(px,py)..get_tile(nx,ny)] then
              return res
            end
            if get_tile(nx, ny) ~= "#" and not (visited[ny] or {})[nx] then
              visited[ny] = visited[ny] or {}
              visited[ny][nx] = true
              next_level[#next_level+1] = {nx, ny}
            end
          end
        end
        level = next_level
        res = res + 1
      until not level[1]
      return math.huge
    end
    local best_move, min_dist = nil, math.huge
    for dn, dp in pairs(dirs) do
      local dx, dy = table.unpack(dp)
      if ({[K..V]=1,[V..K]=1})[get_tile(x,y)..get_tile(x+dx,y+dy)] then
        print"I"
        print(dn)
        return
      end
      local can_dist = dist(x + dx, y + dy)
      if can_dist < min_dist then
        best_move, min_dist = dn, can_dist
      end
    end
    if best_move then
      print"M"
      print(best_move)
      return
    end
    print"P" -- there is nothing we can do
  end
  if table.concat(grid):find"R" then
    murder("P", "R")
  else
    murder("S", "P")
  end
end
